local star=Class("star")
local stageSize=5000
function star:init(bg,count)
	self.parent=bg
	self.count= count or 300
	
	self.points = {}

	for i=1 , self.count do
		local point = {
			offx = lm.random()*stageSize,
			y = lm.random()*stageSize/3+500,
			size = lm.random(1,2),
			alpha = lm.random()*100+155
		}
		table.insert(self.points,point)
	end

end


function star:update()
	self.x=self.parent.pos*5000/24
	for i=1 , self.count do
		local point = self.points[i]
		point.x = self.x + point.offx
		point.x = point.x > 5000 and point.x - 5000 or point.x
	end
end


function star:draw()
	local adj = (12 - math.abs(game.timer.hour-12))*20
	for i=1 , self.count do
		local point = self.points[i]
		love.graphics.setColor(255, 255, 255, point.alpha - adj)
		love.graphics.setPointSize(point.size)
		love.graphics.points(point.x,point.y)
	end
end

return star