local scene = Gamestate.new()

function scene:init()
	game=self
	game.temperature= -10
	game.brightness=1
	game.colorful=1
	game.wind=1
	game.bg =require "stage/background"()
	game.fg =require "stage/foreground"()
	game.timer = require "stage/timer"()
	game.weather = require "stage/weather"()
	game.climate= require "stage/climate"
	game.ui = require "stage/ui_en"
	--game.bgm =  require "stage/player"
end

function scene:reset()
	table.removeItem(game.fg.children,game.tree)
	table.insert(game.fg.children,require "tree/seed"())
end

function scene:screenshot()
    local screenshot = love.graphics.newScreenshot();
 	screenshot:encode("png",os.time() .. '.png');
 	love.system.openURL(love.filesystem.getSaveDirectory())
end

function scene:enter()

end



function scene:draw()
	
	love.graphics.push()
	--love.graphics.scale(0.2, 0.2)
	--love.graphics.translate(-0, -600 )
	love.graphics.translate(-2500+250, -1250 )
    game.bg:draw()
    game.fg:draw()	
    love.graphics.pop()
    ui.draw()
end

function scene:update(dt)
    game.timer:update(dt)
    game.climate:update(dt)
    game.bg:update(dt)
    game.fg:update(dt)
    game.ui:update(dt)
    --game.bgm:update()
end 

function scene:leave()
	
end

function scene:keyreleased(key)
	if key == "f1" then
		self.ui.visible = not self.ui.visible
	elseif key == "f2" then
		self:screenshot()
	end
end

return scene