local interface = {}
interface.visible = true

local color = {
	normal   = {bg = { 255, 1, 255}, fg = {1,200,1}},
	hovered  = {bg = { 50,153,187}, fg = {255,255,255}},
	active   = {bg = {255,153,  0}, fg = {225,225,225}}
}
local title = {text = "心树" , x = 10 , y = 500, color = color}
local month = {text = "月份" , x = 10 , y = 550, w = 100, h = 20, color = color, value = game.timer.month, min = 1, max = 12, step = 1}
local scale = {text = "时比" , x = 10 , y = 600, w = 100, h = 20, color = color, value = game.timer.multiply, min = 1, max = 1000, step = 1}
local apical ={text = "顶端" , x = 10 , y = 650, w = 100, h = 20, color = color, value = game.tree.apicalRate, min = 1, max = 3, step = 1}
local speed = {text = "长势" , x = 10 , y = 700, w = 100, h = 20, color = color, value = game.tree.growRate, min = 0.1, max = 10, step = 1}
function interface:update()
	if not self.visible then return end
	ui.Label(title.text,title,title.x,title.y)
	--------------------------
	ui.Label(month.text,month.x,month.y)
	ui.Label(game.timer.month,month.x+50,month.y)
	if ui.Slider(month,month.x+month.w,month.y,month.w,month.h).changed then
		game.timer.month = math.floor(month.value)
		game.climate:reset()
	end
	-----------------------------
	ui.Label(scale.text,scale.x,scale.y)
	ui.Label(game.timer.multiply,scale.x+50,scale.y)
	if ui.Slider(scale,scale.x+scale.w,scale.y,scale.w,scale.h).changed then
		game.timer.multiply = math.floor(scale.value)
	end
	-----------------------------------
	ui.Label(apical.text,apical.x,apical.y)
	ui.Label(game.tree.apicalRate,apical.x+50,apical.y)
	if ui.Slider(apical,apical.x+apical.w,apical.y,apical.w,apical.h).changed then
		game.tree.apicalRate = apical.value
	end
	-----------------------------------
	ui.Label(speed.text,speed.x,speed.y)
	ui.Label(game.tree.growRate,speed.x+50,speed.y)
	if ui.Slider(speed,speed.x+speed.w,speed.y,speed.w,speed.h).changed then
		game.tree.growRate = speed.value
	end

	ui.Label("迭代 "..game.tree.level,260,550)

	ui.Label("体势 "..game.tree.size ,330,550)

	if ui.Button("重置",420,550,50,30).hit then
		game:reset()
	end

	ui.Label("叶形 "..require("tree/leaf").shapeIndex ,330,600)
	if ui.Button("切换",420,600,50,30).hit then
		local Leaf = require "tree/leaf"
		local shapeIndex = Leaf.shapeIndex+1
		if not Leaf.shapes[shapeIndex] then
			shapeIndex = 1
		end
		Leaf.shapeIndex = shapeIndex
	end


	ui.Label("按f1隐藏ui;f2截图",230,650)
	if ui.Button("截图",420,650,50,30).hit then
		game:screenshot()
	end
	local timer = game.timer
	ui.Label(string.format("现在是：%02d年%02d月%02d日%02d时%02d分",
		timer.year,timer.month,timer.day,timer.hour,timer.minut),title,100,500)
--	print(month.value)
end


return interface