local interface = {}
interface.visible = true

local color = {
	normal   = {bg = { 255, 1, 255}, fg = {1,200,1}},
	hovered  = {bg = { 50,153,187}, fg = {255,255,255}},
	active   = {bg = {255,153,  0}, fg = {225,225,225}}
}
local title = {text = "Tree Sim" , x = 10 , y = 500, color = color}
local month = {text = "Month" , x = 10 , y = 550, w = 100, h = 20, color = color, value = game.timer.month, min = 1, max = 12, step = 1}
local scale = {text = "Time Scale" , x = 10 , y = 600, w = 100, h = 20, color = color, value = game.timer.multiply, min = 1, max = 1000, step = 1}
local apical ={text = "Apical Rate" , x = 10 , y = 650, w = 100, h = 20, color = color, value = game.tree.apicalRate, min = 1, max = 3, step = 1}
local speed = {text = "Grow Speed" , x = 10 , y = 700, w = 100, h = 20, color = color, value = game.tree.growRate, min = 0.1, max = 10, step = 1}
function interface:update()
	if not self.visible then return end
	ui.Label(title.text,title,title.x,title.y)
	--------------------------
	ui.Label(month.text,month.x,month.y)
	ui.Label(game.timer.month,month.x+120,month.y)
	if ui.Slider(month,month.x+160,month.y,month.w,month.h).changed then
		game.timer.month = math.floor(month.value)
		game.climate:reset()
	end
	-----------------------------
	ui.Label(scale.text,scale.x,scale.y)
	ui.Label(game.timer.multiply,scale.x+120,scale.y)
	if ui.Slider(scale,scale.x+160,scale.y,scale.w,scale.h).changed then
		game.timer.multiply = math.floor(scale.value)
	end
	-----------------------------------
	ui.Label(apical.text,apical.x,apical.y)
	ui.Label(game.tree.apicalRate,apical.x+120,apical.y)
	if ui.Slider(apical,apical.x+160,apical.y,apical.w,apical.h).changed then
		game.tree.apicalRate = apical.value
	end
	-----------------------------------
	ui.Label(speed.text,speed.x,speed.y)
	ui.Label(game.tree.growRate,speed.x+120,speed.y)
	if ui.Slider(speed,speed.x+160,speed.y,speed.w,speed.h).changed then
		game.tree.growRate = speed.value
	end

	
	if ui.Button("Reset",400,550,80,30).hit then
		game:reset()
	end

	if ui.Button("shift",400,600,80,30).hit then
		local Leaf = require "tree/leaf"
		local shapeIndex = Leaf.shapeIndex+1
		if not Leaf.shapes[shapeIndex] then
			shapeIndex = 1
		end
		Leaf.shapeIndex = shapeIndex
	end


	ui.Label("Press F1 Hide UI",280,650)
	ui.Label("Press F2 Screenshot",280,700)

	local timer = game.timer
	ui.Label(string.format("Now: Y%02d M%02d D%02d H%02d M%02d",
		timer.year,timer.month,timer.day,timer.hour,timer.minut,timer.season),title,100,500)
--	print(month.value)
end


return interface