local tree=Class("tree")

tree.Node= require "tree2/node"
tree.Leaf= require "tree2/leaf"
tree.Flower= require "tree2/flower"



function tree:init()
	self.x=2500
	self.y=2000
	self.angle=0

	self.tree=self
	self.growSpeed=1
	self.power=1

	self.level=2

	self.branchDirection=1 --作为互生的方向控制

	self.nodeCount=0
	self.nodeLenthLimit=20 --树节点长度，节点越短分支可能越多，长节点的例如竹子，短节点的例如盆景树
	self.nodeLWRatio=5 --树节点长宽比， 越大树木越修长，越短树木越结实

	self.subLeafType="overlapping" --overlapping 互生 pair 对生 wheel 轮生 multy 簇生
	self.subBranchType="dichotomy" --dichotomy 二叉分支 --dichotomy_f 伪二叉 sympodial合轴分枝 Spindle 主轴分支  diff多岐分支
	self.subBranchAngle=Pi/6 --+-45deg 20
	self.subBranchToSkyRate=0.1  --为0时 无方向，为1时完全向上， 为-1时完全向下
	self.apicalLevel=3
	self.softness=0.3
	self.root=self:Node(0,1) --rot,growRate


end

function tree:update(dt)
	self.power=0.9^self.level
	--self.subBranchToSkyRate=1-self.level/8
	--self.apicalLevel=8-self.level/5
	self.root:update(dt)
end

function tree:draw()
	self.root:draw()
end




return tree

--[[
大树属性
大树能量 标准量为1 影响树木生长速度 每节 能量都将衰减 衰减越快 生长越快 主干越长
顶芽衰减 顶端能够更快速的生长
侧芽衰减 侧芽生长更加缓慢
顶端优势层级 顶芽将压制侧芽生长 直到某个层级侧芽开始生长
侧枝角度 一般为30~45度，在交强的方向性时 只能规范初生枝叶的角度

向光性 向光性越高  主干越直，侧枝越张开 否则 树干则倾向于自由生长 无方向性
背地性 背地性越高  所有树枝涨势 越向上收拢 否则 自由生长
顶端性 顶端性越高  主干生长越快 侧枝压制时间越长 侧枝生长越慢
竖直性 树枝性越高  年纪较高的节点间角越低

]]